Index: /java/Framclipse/com.framsticks.framclipse.feature/feature.xml
===================================================================
--- /java/Framclipse/com.framsticks.framclipse.feature/feature.xml	(revision 440)
+++ /java/Framclipse/com.framsticks.framclipse.feature/feature.xml	(revision 441)
@@ -11,17 +11,12 @@
 
    <requires>
-      <import plugin="org.eclipse.xtext" version="1.0.0" match="greaterOrEqual"/>
-      <import plugin="org.eclipse.xtext.util" version="1.0.0" match="greaterOrEqual"/>
-      <import plugin="org.eclipse.emf.ecore"/>
-      <import plugin="org.eclipse.emf.common"/>
+      <import plugin="org.antlr.generator"/>
+      <import plugin="org.eclipse.xtext"/>
       <import plugin="org.antlr.runtime"/>
       <import plugin="org.eclipse.core.runtime"/>
+      <import plugin="org.eclipse.xtext.ui"/>
+      <import plugin="org.eclipse.xtext.ui.shared"/>
+      <import plugin="org.eclipse.xtext.builder"/>
       <import plugin="org.apache.log4j"/>
-      <import plugin="org.eclipse.xtext.ui" version="1.0.0" match="greaterOrEqual"/>
-      <import plugin="org.eclipse.ui.editors" version="3.5.0" match="greaterOrEqual"/>
-      <import plugin="org.eclipse.ui.ide" version="3.5.0" match="greaterOrEqual"/>
-      <import plugin="org.eclipse.xtext.ui.shared" version="1.0.0" match="greaterOrEqual"/>
-      <import plugin="org.eclipse.ui"/>
-      <import plugin="org.eclipse.xtext.builder" version="1.0.0" match="greaterOrEqual"/>
    </requires>
 
@@ -40,10 +35,3 @@
          unpack="false"/>
 
-   <plugin
-         id="com.google.inject"
-         download-size="0"
-         install-size="0"
-         version="0.0.0"
-         unpack="false"/>
-
 </feature>
Index: /java/Framclipse/com.framsticks.framclipse.ui/META-INF/MANIFEST.MF
===================================================================
--- /java/Framclipse/com.framsticks.framclipse.ui/META-INF/MANIFEST.MF	(revision 440)
+++ /java/Framclipse/com.framsticks.framclipse.ui/META-INF/MANIFEST.MF	(revision 441)
@@ -8,14 +8,9 @@
 Require-Bundle: com.framsticks.framclipse;visibility:=reexport,
  org.eclipse.xtext.ui,
- org.eclipse.ui.editors;bundle-version="3.5.0",
- org.eclipse.ui.ide;bundle-version="3.5.0",
  org.eclipse.xtext.ui.shared,
- org.eclipse.ui,
- org.antlr.runtime,
  org.eclipse.xtext.builder
 Import-Package: org.apache.log4j
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Export-Package: com.framsticks.framclipse.ui.contentassist,
- com.framsticks.framclipse.ui.contentassist.antlr,
- com.framsticks.framclipse.ui.quickfix
+ com.framsticks.framclipse.ui.contentassist.antlr
 Bundle-Activator: com.framsticks.framclipse.ui.internal.FramScriptActivator
Index: /java/Framclipse/com.framsticks.framclipse.ui/plugin.xml
===================================================================
--- /java/Framclipse/com.framsticks.framclipse.ui/plugin.xml	(revision 440)
+++ /java/Framclipse/com.framsticks.framclipse.ui/plugin.xml	(revision 441)
@@ -35,5 +35,25 @@
             </reference>
          </activeWhen>
-      </handler>
+      	</handler>
+      	<!-- copy qualified name -->
+        <handler
+            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedNameHandler"
+            commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName">
+            <activeWhen>
+				<reference definitionId="com.framsticks.framclipse.FramScript.Editor.opened" />
+            </activeWhen>
+        </handler>
+        <handler
+            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedNameHandler"
+            commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedName">
+            <activeWhen>
+            	<and>
+            		<reference definitionId="com.framsticks.framclipse.FramScript.XtextEditor.opened" />
+	                <iterate>
+						<adapt type="org.eclipse.xtext.ui.editor.outline.IOutlineNode" />
+					</iterate>
+				</and>
+            </activeWhen>
+        </handler>
     </extension>
     <extension point="org.eclipse.core.expressions.definitions">
@@ -41,4 +61,14 @@
             <and>
                 <reference definitionId="isActiveEditorAnInstanceOfXtextEditor"/>
+                <with variable="activeEditor">
+                    <test property="org.eclipse.xtext.ui.editor.XtextEditor.languageName" 
+                        value="com.framsticks.framclipse.FramScript" 
+                        forcePluginActivation="true"/>
+                </with>        
+            </and>
+        </definition>
+        <definition id="com.framsticks.framclipse.FramScript.XtextEditor.opened">
+            <and>
+                <reference definitionId="isXtextEditorActive"/>
                 <with variable="activeEditor">
                     <test property="org.eclipse.xtext.ui.editor.XtextEditor.languageName" 
@@ -73,4 +103,17 @@
     </extension>
     <extension
+            point="org.eclipse.ui.propertyPages">
+        <page
+            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.preferences.LanguageRootPreferencePage"
+            id="com.framsticks.framclipse.FramScript"
+            name="FramScript">
+            <keywordReference id="com.framsticks.framclipse.ui.keyword_FramScript"/>
+            <enabledWhen>
+	            <adapt type="org.eclipse.core.resources.IProject"/>
+			</enabledWhen>
+	        <filter name="projectNature" value="org.eclipse.xtext.ui.shared.xtextNature"/>
+        </page>
+    </extension>
+    <extension
         point="org.eclipse.ui.keywords">
         <keyword
@@ -84,4 +127,17 @@
             id="com.framsticks.framclipse.FramScript.validate"
             name="Validate">
+      </command>
+      <!-- copy qualified name -->
+      <command
+            id="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName"
+            categoryId="org.eclipse.ui.category.edit"
+            description="Copy the qualified name for the selected element"
+            name="Copy Qualified Name">
+      </command>
+      <command
+            id="org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedName"
+            categoryId="org.eclipse.ui.category.edit"
+            description="Copy the qualified name for the selected element"
+            name="Copy Qualified Name">
       </command>
     </extension>
@@ -100,4 +156,34 @@
          </command>  
          </menuContribution>
+         <!-- copy qualified name -->
+         <menuContribution locationURI="popup:#TextEditorContext?after=copy">
+         	<command commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName" 
+         		style="push" tooltip="Copy Qualified Name">
+            	<visibleWhen checkEnabled="false">
+                	<reference definitionId="com.framsticks.framclipse.FramScript.Editor.opened" />
+            	</visibleWhen>
+         	</command>  
+         </menuContribution>
+         <menuContribution locationURI="menu:edit?after=copy">
+         	<command commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.EditorCopyQualifiedName"
+            	style="push" tooltip="Copy Qualified Name">
+            	<visibleWhen checkEnabled="false">
+                	<reference definitionId="com.framsticks.framclipse.FramScript.Editor.opened" />
+            	</visibleWhen>
+         	</command>  
+         </menuContribution>
+         <menuContribution locationURI="popup:org.eclipse.xtext.ui.outline?after=additions">
+			<command commandId="org.eclipse.xtext.ui.editor.copyqualifiedname.OutlineCopyQualifiedName" 
+				style="push" tooltip="Copy Qualified Name">
+         		<visibleWhen checkEnabled="false">
+	            	<and>
+	            		<reference definitionId="com.framsticks.framclipse.FramScript.XtextEditor.opened" />
+						<iterate>
+							<adapt type="org.eclipse.xtext.ui.editor.outline.IOutlineNode" />
+						</iterate>
+					</and>
+				</visibleWhen>
+			</command>
+         </menuContribution>
     </extension>
     <extension point="org.eclipse.ui.menus">
@@ -210,5 +296,26 @@
 
 
-
+    <!-- marker definitions for com.framsticks.framclipse.FramScript -->
+    <extension
+            id="framscript.check.fast"
+            name="FramScript Problem"
+            point="org.eclipse.core.resources.markers">
+        <super type="org.eclipse.xtext.ui.check.fast"/>
+        <persistent value="true"/>
+    </extension>
+    <extension
+            id="framscript.check.normal"
+            name="FramScript Problem"
+            point="org.eclipse.core.resources.markers">
+        <super type="org.eclipse.xtext.ui.check.normal"/>
+        <persistent value="true"/>
+    </extension>
+    <extension
+            id="framscript.check.expensive"
+            name="FramScript Problem"
+            point="org.eclipse.core.resources.markers">
+        <super type="org.eclipse.xtext.ui.check.expensive"/>
+        <persistent value="true"/>
+    </extension>
 
 	<!-- Quick Outline -->
@@ -245,10 +352,32 @@
 		</menuContribution>
 	</extension>
-   <!-- quickfix marker resolution generator -->
-   <extension
-         point="org.eclipse.ui.ide.markerResolution">
-      <markerResolutionGenerator
-            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator">
-      </markerResolutionGenerator>
-   </extension>
+    <!-- quickfix marker resolution generator for com.framsticks.framclipse.FramScript -->
+    <extension
+            point="org.eclipse.ui.ide.markerResolution">
+        <markerResolutionGenerator
+            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator"
+            markerType="com.framsticks.framclipse.ui.framscript.check.fast">
+            <attribute
+                name="FIXABLE_KEY"
+                value="true">
+            </attribute>
+        </markerResolutionGenerator>
+        <markerResolutionGenerator
+            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator"
+            markerType="com.framsticks.framclipse.ui.framscript.check.normal">
+            <attribute
+                name="FIXABLE_KEY"
+                value="true">
+            </attribute>
+        </markerResolutionGenerator>
+        <markerResolutionGenerator
+            class="com.framsticks.framclipse.ui.FramScriptExecutableExtensionFactory:org.eclipse.xtext.ui.editor.quickfix.MarkerResolutionGenerator"
+            markerType="com.framsticks.framclipse.ui.framscript.check.expensive">
+            <attribute
+                name="FIXABLE_KEY"
+                value="true">
+            </attribute>
+        </markerResolutionGenerator>
+    </extension>
+
 </plugin>
Index: /java/Framclipse/com.framsticks.framclipse/META-INF/MANIFEST.MF
===================================================================
--- /java/Framclipse/com.framsticks.framclipse/META-INF/MANIFEST.MF	(revision 440)
+++ /java/Framclipse/com.framsticks.framclipse/META-INF/MANIFEST.MF	(revision 441)
@@ -6,22 +6,14 @@
 Bundle-SymbolicName: com.framsticks.framclipse; singleton:=true
 Bundle-ActivationPolicy: lazy
-Require-Bundle: org.eclipse.xtext,
+Require-Bundle: org.antlr.generator,
+ org.eclipse.xtext,
  org.eclipse.xtext.generator;resolution:=optional,
  de.itemis.xtext.antlr;resolution:=optional,
  org.apache.commons.logging;resolution:=optional,
- org.eclipse.emf.codegen.ecore;resolution:=optional,
- org.eclipse.emf.mwe.utils;resolution:=optional,
  org.eclipse.emf.mwe2.launch;resolution:=optional,
- com.ibm.icu;resolution:=optional,
- org.eclipse.xtext.util,
- org.eclipse.emf.ecore,
- org.eclipse.emf.common,
  org.antlr.runtime,
- org.eclipse.core.runtime,
- org.eclipse.xtext.xbase.lib
-Import-Package: org.apache.log4j
+ org.eclipse.core.runtime
 Bundle-RequiredExecutionEnvironment: JavaSE-1.6
 Export-Package: com.framsticks.framclipse,
- com.framsticks.framclipse.formatting,
  com.framsticks.framclipse.framScript,
  com.framsticks.framclipse.framScript.impl,
@@ -29,9 +21,10 @@
  com.framsticks.framclipse.parser.antlr,
  com.framsticks.framclipse.parser.antlr.internal,
- com.framsticks.framclipse.scoping,
  com.framsticks.framclipse.script,
  com.framsticks.framclipse.script.model,
- com.framsticks.framclipse.serializer,
  com.framsticks.framclipse.services,
  com.framsticks.framclipse.validation
-Bundle-ClassPath: lib/commons-io-1.4.jar,lib/xpp3_min-1.1.4c.jar,lib/xstream-1.3.1.jar,.
+Bundle-ClassPath: lib/commons-io-1.4.jar,
+ lib/xpp3_min-1.1.4c.jar,
+ lib/xstream-1.3.1.jar,
+ .