Index: /experiments/frams/evolve-speed-vs-gravity/go-evol-water.cmd
===================================================================
--- /experiments/frams/evolve-speed-vs-gravity/go-evol-water.cmd	(revision 462)
+++ /experiments/frams/evolve-speed-vs-gravity/go-evol-water.cmd	(revision 463)
@@ -5,5 +5,5 @@
 for %%G in (1.0) do (
 
-frams "ex standard" "Simulator.creatwarnfail=1;" "World.wrldwat=20;" "ExpParams.stagnation=30000;" "Populations[0].nnsim=Populations[0].enableperf=1;" "ExpParams.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity(%%G,100);" -q >exp-evol-speed\testwater_%%G_%%R.out
+frams "ex standard" "Simulator.creatwarnfail=1;" "World.wrldwat=20;" "ExpParams.stagnation=30000;" "Populations[0].nnsim=Populations[0].enableperf=1;" "ExpParams.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity_args(%%G,100);" -q >exp-evol-speed\testwater_%%G_%%R.out
 
 )
Index: /experiments/frams/evolve-speed-vs-gravity/go-evol.cmd
===================================================================
--- /experiments/frams/evolve-speed-vs-gravity/go-evol.cmd	(revision 462)
+++ /experiments/frams/evolve-speed-vs-gravity/go-evol.cmd	(revision 463)
@@ -5,5 +5,5 @@
 for %%G in (0.2,0.4,0.6,0.8,1.0, 1.2,1.4,1.6,1.8,2.0) do (
 
-frams "ex standard" "Simulator.creatwarnfail=1;" "ExpParams.stagnation=30000;" "ExpParams.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity(%%G,100);" -q >exp-evol-speed\test_%%G_%%R.out
+frams "ex standard" "Simulator.creatwarnfail=1;" "ExpParams.stagnation=30000;" "ExpParams.minfitness=0.00001;" "UserScripts.script_Evolve_for_speed_vs_gravity_args(%%G,100);" -q >exp-evol-speed\test_%%G_%%R.out
 
 )
Index: /experiments/frams/multi-threading/test-mt.cmd
===================================================================
--- /experiments/frams/multi-threading/test-mt.cmd	(revision 462)
+++ /experiments/frams/multi-threading/test-mt.cmd	(revision 463)
@@ -1,8 +1,8 @@
 
-for %%C in (5,10,25,50,100,200) do (
-for %%T in (1,2,3,4,5,6) do (
+for %%C in (5,10,25,50,100,200,400,600) do (
+for %%T in (1,2,3,4,5,6,7,8,9,10,11,12,16,20) do (
 
 rem real task: maximize fitness=velocity
-rem frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test(0,120,10);" -q >exp-evol-speed\test_%%T_%%C.out
+rem frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(0,120,10);" -q >exp-evol-speed\test_%%T_%%C.out
 
 
@@ -12,10 +12,14 @@
 
 rem no mutation, no crossover, only cloning - so that the same genotype is always evaluated. Useful to measure "raw" efficiency of parallel computation
-frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.p_mut=0;" "ExpParams.p_xov=0;" "ExpParams.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test(0,6,10);" -q >exp-evol-speed-nochange\test_%%T_%%C.out
+rem frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.p_mut=0;" "ExpParams.p_xov=0;" "ExpParams.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(0,6,10);" -q >exp-evol-speed-nochange\test_%%T_%%C.out
 
 
 rem same as above but with a bigger genotype, so that the time spent on script processing is relatively shorter, and more time is used for pure simulation 
-frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.p_mut=0;" "ExpParams.p_xov=0;" "ExpParams.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test(6,6,10);" -q >exp-evol-speed-nochange-biggeno\test_%%T_%%C.out
+rem frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.p_mut=0;" "ExpParams.p_xov=0;" "ExpParams.capacity=%%C;" "UserScripts.script_Multithreading_efficiency_test_args(6,6,10);" -q >exp-evol-speed-nochange-biggeno\test_%%T_%%C.out
+
+
+rem keep threads running and only cloning
+frams "ex standard-mt" "ExpParams.threads=%%T;" "ExpParams.capacity=%%C;" "ExpParams.p_mut=0;" "ExpParams.p_xov=0;" "ExpParams.keep_threads_running=1;" "UserScripts.script_Multithreading_efficiency_test_args(3,50,10);" -q >exp-evol-speed-nochange-keeprunning\test_%%T_%%C.out
+
 
 ))
-