Index: experiments/frams/capture-the-flag/data/scripts/Flag.neuro
===================================================================
--- experiments/frams/capture-the-flag/data/scripts/Flag.neuro	(revision 233)
+++ experiments/frams/capture-the-flag/data/scripts/Flag.neuro	(revision 480)
@@ -10,5 +10,5 @@
 function init(){
 //	Neuro.signals.add("Flag");
-//	Neuro.signals[0].flavor = Fields.team;
+//	Neuro.signals[0].flavor = NeuroProperties.team;
 //	Neuro.signals[0].power = 0;
 }
@@ -16,5 +16,5 @@
 function go()
 {
-	var output = Neuro.signals.receiveFilter("Flag", 2000, Fields.team, 0.5);
+	var output = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.team, 0.5);
 	Neuro.state = output;
 	
@@ -22,5 +22,5 @@
 ~
 
-prop:
+property:
 id:team
 name:Team number
Index: experiments/frams/capture-the-flag/data/scripts/FlagDef.neuro
===================================================================
--- experiments/frams/capture-the-flag/data/scripts/FlagDef.neuro	(revision 233)
+++ experiments/frams/capture-the-flag/data/scripts/FlagDef.neuro	(revision 480)
@@ -10,5 +10,5 @@
 function init(){
 //	Neuro.signals.add("Flag");
-//	Neuro.signals[0].flavor = Fields.team;
+//	Neuro.signals[0].flavor = NeuroProperties.team;
 //	Neuro.signals[0].power = 0;
 }
@@ -17,22 +17,22 @@
 {
 	//Check own flag
-	if (Neuro.signals.receiveFilter("Flag", 2000, Fields.my + 100, 0.5) > 0)
-		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, Fields.my + 100, 0.5);
+	if (Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.my + 100, 0.5) > 0)
+		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.my + 100, 0.5);
 	//Check opponent flag
 	//If flag is taken -> go to own flag
-	else if (Neuro.signals.receiveFilter("Flag", 2000, Fields.opp + 100, 0.5) > 0)	
-		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, Fields.my, 0.5);
+	else if (Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.opp + 100, 0.5) > 0)	
+		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.my, 0.5);
 	//else -> go to opponent flag
 	else
-		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, Fields.opp, 0.5);
+		Neuro.state = Neuro.signals.receiveFilter("Flag", 2000, NeuroProperties.opp, 0.5);
 }
 ~
 
-prop:
+property:
 id:opp
 name:Opponent team number
 type:d
 
-prop:
+property:
 id:my
 name:My team number
Index: experiments/frams/capture-the-flag/data/scripts/capture-the-flag.expdef
===================================================================
--- experiments/frams/capture-the-flag/data/scripts/capture-the-flag.expdef	(revision 233)
+++ experiments/frams/capture-the-flag/data/scripts/capture-the-flag.expdef	(revision 480)
@@ -28,11 +28,11 @@
    	World.wrldbnd = 2; //Teleport
    	
-   	ExpParams.memberssno = 4;
-   	ExpParams.teamsno = 2;
-   	ExpParams.mindistance = 60;
+   	ExpProperties.memberssno = 4;
+   	ExpProperties.teamsno = 2;
+   	ExpProperties.mindistance = 60;
    	
-   	ExpParams.pointsCapture = 10;
-   	ExpParams.pointsRetrieve = 5;
-   	ExpParams.pointsScoring = 50;
+   	ExpProperties.pointsCapture = 10;
+   	ExpProperties.pointsRetrieve = 5;
+   	ExpProperties.pointsScoring = 50;
 
 	//Styles of flags
@@ -50,5 +50,5 @@
 function onExpInit()
 {
-	ExpParams_create_call();
+	ExpProperties_create_call();
 
 }
@@ -84,5 +84,5 @@
 }
 
-function ExpParams_create_call(){
+function ExpProperties_create_call(){
 	//Create GenePool and Population for each team
 	GenePools.clear();
@@ -106,5 +106,5 @@
 	
 	var i = 2;
-	for (i = 2; i <= ExpParams.teamsno; i++){
+	for (i = 2; i <= ExpProperties.teamsno; i++){
 		pop=Populations.addGroup("Team"+i);
 		pop.selfmask = 0x50001;
@@ -124,5 +124,5 @@
 }
 
-function ExpParams_fill_call(){
+function ExpProperties_fill_call(){
 	var team = 0;
 	var player = 0;
@@ -141,5 +141,5 @@
 	var ok = 0;
 	
-	for (i = 0; i < ExpParams.teamsno; i++){
+	for (i = 0; i < ExpProperties.teamsno; i++){
 		points.add(0);
 		scored.add(0);
@@ -149,5 +149,5 @@
 	
 	//Clear Populations
-	for (team = 0; team < ExpParams.teamsno; team++){
+	for (team = 0; team < ExpProperties.teamsno; team++){
 		while (Populations[team].size > 0)
 			Populations[team].delete(0);
@@ -162,5 +162,5 @@
 
 		ok = 1;		
-		while (flagsX.size < ExpParams.teamsno && ok == 1){
+		while (flagsX.size < ExpProperties.teamsno && ok == 1){
 			ok = 0;
 			flagTries = 0;
@@ -171,5 +171,5 @@
 				ok = 1;
 				for (i = 0; i < flagsX.size; i++){
-					if (Math.sqrt(Math.pow(flagsX[i] - x, 2)+Math.pow(flagsY[i] - y,2)) < ExpParams.mindistance){
+					if (Math.sqrt(Math.pow(flagsX[i] - x, 2)+Math.pow(flagsY[i] - y,2)) < ExpProperties.mindistance){
 						ok = 0;
 						break;
@@ -185,5 +185,5 @@
 		}
 		
-		if (flagsX.size == ExpParams.teamsno)
+		if (flagsX.size == ExpProperties.teamsno)
 			done = 1;
 		else
@@ -199,9 +199,9 @@
 	
 	//Fill each team's Population with players and a flag and place players close to their flag
-	for (team = 0; team < ExpParams.teamsno; team++){
+	for (team = 0; team < ExpProperties.teamsno; team++){
 		while (Populations[team].size > 0)
 			Populations[team].delete(0);
 		
-		var cr = Populations[team].add(GenePools[ExpParams.teamsno][team]);
+		var cr = Populations[team].add(GenePools[ExpProperties.teamsno][team]);
 		placeFlag(cr);
 		cr.signals.add("Flag");
@@ -214,5 +214,5 @@
 		var crX, crY;
 		
-		for (player = 0; player < ExpParams.memberssno; player++){
+		for (player = 0; player < ExpProperties.memberssno; player++){
 		        var pool=GenePools[team];
 			cr = Populations[team].add(pool[player % pool.size]);
@@ -235,8 +235,8 @@
 }
 
-function ExpParams_default_call(){
+function ExpProperties_default_call(){
 	//Insert default player genotype in team's GenePools
 	var team = 0;
-	for (team = 0; team < ExpParams.teamsno; team++){
+	for (team = 0; team < ExpProperties.teamsno; team++){
 		while (GenePools[team].size > 0)
 			GenePools[team].delete(0);
@@ -272,5 +272,5 @@
 //		line=line+Simulator.time+";";
 //		
-//		for (i = 0; i < ExpParams.teamsno; i++){
+//		for (i = 0; i < ExpProperties.teamsno; i++){
 //			line=line+points[i]+";"+scored[i]+";"+taken[i]+";"+retrieved[i]+";";
 //		}
@@ -299,10 +299,10 @@
 	
 	//Score points for taking a flag
-	creature.user3 += ExpParams.pointsCapture;
+	creature.user3 += ExpProperties.pointsCapture;
 	
 //	Simulator.print("Flag "+(flag.group.index+1)+" taken by team "+(creature.group.index+1));
 	
 	//Update team points and events
-	points[creature.population.index] = points[creature.population.index] + ExpParams.pointsCapture;
+	points[creature.population.index] = points[creature.population.index] + ExpProperties.pointsCapture;
 	taken[creature.population.index] = taken[creature.population.index] + 1;
 
@@ -325,10 +325,10 @@
 
 	//Score points for retrieving a flag
-	creature.user3 += ExpParams.pointsRetrieve;
+	creature.user3 += ExpProperties.pointsRetrieve;
 	
 //	Simulator.print("Flag "+ (flag.group.index+1) +" retrieved");
 	
 	//Update team scores
-	points[creature.population.index] = points[creature.population.index] + ExpParams.pointsRetrieve;
+	points[creature.population.index] = points[creature.population.index] + ExpProperties.pointsRetrieve;
 	retrieved[creature.population.index] = retrieved[creature.population.index] + 1;
 }
@@ -346,10 +346,10 @@
 	
 	//Score points for scoring a flag
-	creature.user3 += ExpParams.pointsScoring;
+	creature.user3 += ExpProperties.pointsScoring;
 	
 //	Simulator.print("Team "+ (creature.group.index + 1) +" scored");
 	
 	//Update team points
-	points[creature.population.index] = points[creature.population.index] + ExpParams.pointsScoring;
+	points[creature.population.index] = points[creature.population.index] + ExpProperties.pointsScoring;
 	scored[creature.population.index] = scored[creature.population.index] + 1;
 }
@@ -419,45 +419,45 @@
 ~
 
-prop:
+property:
 id:teamsno
 name:Number of teams
 type:d 2 5
 
-prop:
+property:
 id:memberssno
 name:Number of members in team
 type:d 1 8
 
-prop:
+property:
 id:mindistance
 name:Minimal distance between flags
 type:d 1 100
 
-prop:
+property:
 id:create
 name:Create teams
 type:p
 
-prop:
+property:
 id:default
 name:Insert default player
 type:p
 
-prop:
+property:
 id:fill
 name:Fill teams
 type:p
 
-prop:
+property:
 id:pointsCapture
 name:Points for flag capture
 type:d 0 100
 
-prop:
+property:
 id:pointsRetrieve
 name:Points for flag retrieve
 type:d 0 100
 
-prop:
+property:
 id:pointsScoring
 name:Points for scoring a flag
Index: experiments/frams/capture-the-flag/data/scripts/threshold2.neuro
===================================================================
--- experiments/frams/capture-the-flag/data/scripts/threshold2.neuro	(revision 233)
+++ experiments/frams/capture-the-flag/data/scripts/threshold2.neuro	(revision 480)
@@ -20,8 +20,8 @@
 function go()
 {
-  if (Neuro.weightedInputSum >= Fields.t)
-    Neuro.state = Fields.hi;
-  else if (Neuro.weightedInputSum <= -Fields.t)
-    Neuro.state = Fields.lo;
+  if (Neuro.weightedInputSum >= NeuroProperties.t)
+    Neuro.state = NeuroProperties.hi;
+  else if (Neuro.weightedInputSum <= -NeuroProperties.t)
+    Neuro.state = NeuroProperties.lo;
   else
     Neuro.state = Neuro.weightedInputSum;
@@ -29,15 +29,15 @@
 ~
 
-prop:
+property:
 id:t
 name:threshold
 type:f
 
-prop:
+property:
 id:lo
 name:low output value
 type:f
 
-prop:
+property:
 id:hi
 name:high output value